#include "dcdialog.ch"
#INCLUDE "appevent.CH"

Function Main()

/* This example shows "Scrolling" @ DCSAY..GETs.  Moving the
   scrollbars will scroll the GETS in the window.  Moving to a
   GET which is outside the window area will scroll the GETS
   up or down.  Resizing the window will resize the GET area. */

 LOCAL GetList := {}, i, nCount := 0, oStatic, ;
       nVertOffset := 0, oVertScroll, oDlg, oCurrGet, bGotFocus, ;
       GetOptions, nRows, aData[50]

 AFill(aData,Space(20))

 nRows := Len(aData)

 bGotFocus := {|a,b,o|AdjustOffset(o,oStatic,@nVertOffset, ;
                      oVertScroll,nRows), oCurrGet:=o}

 @ 1,1 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 80, nRows-1 ;
   OBJECT oStatic ;
   ;// COLOR nil, GRA_CLR_CYAN ;
   RESIZE DCGUI_RESIZE_RESIZEONLY

 @ 1, 81.2 DCSCROLLBAR DATA nVertOffSet SIZE 3,nRows-1 ;
   TYPE XBPSCROLL_VERTICAL ;
   RANGE 0,(nRows-1)*20 ;
   AUTOTRACK ;
   RESIZE DCGUI_RESIZE_RESIZEY_REPOSX ;
   OBJECT oVertScroll ;
   SCROLL { |a,x,o|nVertOffset := a[1], ;
             oStatic:lockUpdate(.t.), ;
             ScrollChildren(oStatic,nVertOffSet), ;
             oStatic:lockUpdate(.f.), ;
             oStatic:invalidateRect() }

 FOR i := 1 TO Len(aData)
   @ nCount,1 DCSAY 'Get # ' + Alltrim(Str(i)) GET aData[i] ;
       SAYRIGHTBOTTOM ;
       SAYSIZE 15 ;
       SAYEVAL AnchorRow(i) ;
       GETEVAL AnchorRow(i) ;
       GETID 'GET_' + Alltrim(Str(i)) ;
       PARENT oStatic ;
       GOTFOCUS bGotFocus ;
       RESIZE DCGUI_RESIZE_REPOSONLY_Y
   nCount++
 NEXT

 DCHOTKEY xbeK_PGUP ACTION {||PgUp(GetList,oStatic)}
 DCHOTKEY xbeK_PGDN ACTION {||PgDn(GetList,oStatic)}

 DCGETOPTIONS RESIZE

 DCREAD GUI ;
   PARENT @oDlg ;
   TITLE 'Scrolling GETS Demo' ;
   FIT ;
   MODAL ;
   NOAUTORESTORE ;
   OPTIONS GetOptions ;
   EVAL {|o|o:setSize({o:currentSize()[1],400})}

RETURN nil

* ------------

STATIC FUNCTION PgUp(GetList,oStatic)

LOCAL nID := SetAppFocus():_id, nPageSize, oXbp, aChildren, nFound

nPageSize := PageSize(oStatic)-1
nID -= nPageSize

aChildren := oStatic:childList()
nFound := AScan( aChildren,{|o|o:isDerivedFrom('DC_XbpGet') .AND. o:_id=nID})
IF nFound > 0
  SetAppFocus(aChildren[nFound])
ELSE
  SetAppFocus(aChildren[2])
ENDIF
oStatic:invalidateRect()

RETURN nil

* ------------

STATIC FUNCTION PgDn(GetList,oStatic)

LOCAL nID := SetAppFocus():_id, nPageSize, oXbp, aChildren, nFound

nPageSize := PageSize(oStatic)-1
nID += nPageSize

aChildren := oStatic:childList()
nFound := AScan( aChildren,{|o|o:isDerivedFrom('DC_XbpGet') .AND. o:_id=nID})
IF nFound > 0
  SetAppFocus(aChildren[nFound])
ELSE
  SetAppFocus(aChildren[Len(aChildren)])
ENDIF
oStatic:invalidateRect()

RETURN nil

* ------------

STATIC FUNCTION PageSize(oStatic)

LOCAL i, oXbp, aChildren := oStatic:childList(), nGets := 0

FOR i := 1 TO Len(aChildren)
  oXbp := aChildren[i]
  IF oXbp:isDerivedFrom('DC_XbpGet')
    IF !(oXbp:currentPos()[2] < 0 .OR. oXbp:currentPos()[2] > oXbp:parent:currentSize()[2])
      nGets++
    ENDIF
  ENDIF
NEXT

RETURN nGets

* ------------

STATIC FUNCTION AnchorRow( i )

RETURN {|o|o:_currentPos := o:currentPos(), ;
           o:_currentRow := i-1, ;
           o:_id := i}

* ------------

STATIC FUNCTION ScrollChildren( oStatic, nVertOffset )

LOCAL aChildren := oStatic:ChildList(), i, aCargo, nRow, nCol, oXbp, ;
      aCurrentPos

oStatic:lockUpdate(.t.)
FOR i := 1 TO LEN(aChildren)
  oXbp := aChildren[i]
  aCurrentPos := oXbp:_currentPos
  nRow := aCurrentPos[2]
  oXbp:setPos({oXbp:currentPos()[1],nRow+nVertOffset})
NEXT
oStatic:lockUpdate(.f.)

RETURN nil

* -------------

STATIC FUNCTION AdjustOffset( oXbp, oStatic, nVertOffset, oVertScroll, nRows )

LOCAL aCargo, nRow, nOffset, lInvalidate := .f.

IF Valtype(oXbp) = 'U'
  RETURN nil
ENDIF

DO WHILE oXbp:currentPos()[2] - oXbp:parent:currentPos()[2] < 0
  nVertOffset += 20
  ScrollChildren( oStatic, nVertOffset )
  lInvalidate := .t.
ENDDO
DO WHILE oXbp:currentPos()[2] > oStatic:currentSize()[2]-20
  nVertOffset -= 20
  ScrollChildren( oStatic, nVertOffset )
  lInvalidate := .t.
ENDDO
IF lInvalidate
  oStatic:invalidateRect()
ENDIF

nRow := oXbp:_currentPos[2]

oVertScroll:setData( oXbp:_currentRow*20 )

RETURN nil

* ------------

PROC appsys ; return
